﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;

using Teigha.Colors;
using Teigha.DatabaseServices;
using Bricscad.ApplicationServices;
using Teigha.Geometry;
using Bricscad.EditorInput;
using Teigha.Runtime;
using Bricscad.Runtime;

namespace BricsCadTemplate
{
    public class Loader : IExtensionApplication
    {
        public void Initialize()
        {
        }

        public void Terminate()
        {
        }

        [LispFunction("Net:RetrieveSomeText")]
        public static object RetrieveSomeText(ResultBuffer resBuf)
        {
            var pars = new ResultBuffer(new[] { new TypedValue((int)LispDataType.Text, "get_a_string_from_lisp") });
            var result = Bricscad.Global.Editor.Invoke(pars);

            return result?.AsArray() is TypedValue[] args
                && args.Length > 0
                && args[0] is TypedValue arg
                && arg.TypeCode == (short)LispDataType.Text
                && arg.Value is string textFromLisp
                ? new TypedValue((int)LispDataType.Text, "Text from invoke Lisp: " + textFromLisp + "\n")
                : new TypedValue((int)LispDataType.Text, "No result from invoke Lisp.\n");
        }
    }
}
